// Copyright (c) 2015, Giliam de Carpentier
// All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
// 
// 1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
// 
// 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the 
// documentation and/or other materials provided with the distribution.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED 
// TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR 
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// Class structure based on code from the Ogre3D SDK, Copyright (c) 2000-2012 Torus Knot Software Ltd.

#pragma once

#include "BaseApplication.h"

namespace LensDistortion
{
class NormalizedDistortion;
}

class LensDistortionApplication : public BaseApplication
{
public:
    LensDistortionApplication(void);
    virtual ~LensDistortionApplication(void);


protected:
    virtual void createScene(void);

    virtual bool frameRenderingQueued(const Ogre::FrameEvent& evt);
    virtual bool keyPressed( const OIS::KeyEvent &arg );
	virtual bool mousePressed( const OIS::MouseEvent &arg, OIS::MouseButtonID id );

	void updateCameraFOV(const LensDistortion::NormalizedDistortion& distortion);
	void updateStatistics(const LensDistortion::NormalizedDistortion& distortion);
	void updateLensDistortionShaderParameters(const LensDistortion::NormalizedDistortion& distortion);

private:
    OgreBites::ParamsPanel* mCameraPanel;
	OgreBites::Slider* mFOVSlider;
	OgreBites::Slider* mDistortionSlider;
	OgreBites::CheckBox* mAutoDirectionCheckbox;
	OgreBites::Slider* mCylindericalRatioSlider;
	OgreBites::CheckBox* mSkipPostEffectCheckbox;
	Ogre::AnimationState* mCharacterAnimationState;
};
